<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 03/22/2004 *
 * ================                             Last change: 12/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-extentions.php                              *
 * -------------------------------------------------------------------- *
 * Short description : Extension management                             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Erweiterungen-Management                         *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

// Normally we want the overview of all registered theme_check
$mode = 'overview';
$SEL = 0;

// Get response from our server
$response = sendGetRequest('check-themes.php');

// Are theme_check found?
if (($response[count($response) - 1] == "[EOF]") && ($response[0] != "[EOF]")) {
	// Ok, mark found and create the array
	$themes = array(
		'fname'  => array(), // File names
		'fsize'  => array(), // File size
		'fctime' => array(), // File creation timestamp
		'infos'  => array(), // File informations (maybe loaded!)
		'ver'    => array(), // Version number
		'cver'   => array(), // Current version number
	);

	// Get count of theme_check for validation
	$count = trim($response[count($response) - 2]);
	foreach ($response as $idx => $value) {
		$value = str_replace("\n", '', $value); $ver = '';

		// Leave loop when data is invalid or EOF?
		if ((substr($value, 0, 6) == "theme-") && (substr($value, -4) == ".zip")) {
			// Extract name and version
			$name = substr($value, 6, -4);
			$ver  = trim(substr($response[$idx + 3], 4));

			// Load version
			$cver = getThemeVersion($name);

			// Is the theme already installed or not?
			if (($ver != $cver) && ($cver != '?') && ($cver != '!')) {
				// No, it isn't. So let's add this one!
				$themes['fname'][]  = $name;
				$themes['fsize'][]  = $response[$idx + 1];
				$themes['fctime'][] = $response[$idx + 2];
				$themes['ver'][]    = $ver;
				$themes['cver'][]   = $cver;

				// Extract language strings from reponse
				$langDummy = explode('[nl]', $response[$idx + 4]);
				$languages = array();
				$themeInfo = getMessage('ADMIN_EXT_NO_INFO_FOUND');

				// Trim every data line
				foreach ($langDummy as $k => $v) {
					$v = trim($v);
					if (substr($v, 3) == '') $v = '---';
					$langDummy[$k] = $v;
					if ($v == 'xx:xx') break;
					$languages[] = $v;
				} // END - foreach

				// If language is found stop searching on matching line
				foreach($languages as $search) {
					if (substr($search, 0, 3) == (getLanguage().':')) { $themeInfo = substr($search, 3); break; }
				} // END - foreach

				// Add informations to array
				$themes['infos'][] = $themeInfo;
			} // END - if
		} // END - if
	} // END - foreach

	// Ok, themes are on our server but maybe you have already installed them?
	if (count($themes['fname']) > 0) {
		// Sort array (I missed ver and cver here)
		array_pk_sort($themes, array('cver', 'fname'), 0, 1);

		// Extensions where found which are not downloaded and installed
		$OUT = ''; $SW = 2; $totalSize = 0;
		foreach ($themes['fname'] as $idx => $name) {
			// Prepare data
			$content = array(
				'sw'      => $SW,
				'index'   => ($idx + 1),
				'name'    => $name,
				'created' => generateDateTime($themes['fctime'][$idx], 2),
				'size'    => translateComma(round($themes['fsize'][$idx] / 1.024) / 1000),
				'version' => $themes['ver'][$idx],
				'current' => $themes['cver'][$idx],
				'infos'   => $themes['infos'][$idx],
			);

			// Load row template
			$OUT .= loadTemplate('admin_list_theme_row', true, $content);

			// Add total size
			$totalSize += $themes['fsize'][$idx];

			// Switch color
			$SW = 3 - $SW;
		}
		$content['rows']   = $OUT;
		$content['total']  = count($themes['fname']);
		$content['kbytes'] = translateComma(round($totalSize / 1.024) / 1000);

		// Load template
		loadTemplate('admin_list_theme', false, $content);
	} else {
		// All Themes are downloaded and installed
		loadTemplate('admin_theme_installed', false, $count);
	}
} else {
	// No theme where found
	loadTemplate('admin_settings_saved', false, getMessage('ADMIN_THEME_NOTHING_FOUND'));
}

// [EOF]
?>
